// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/ao_chan_sel.c $
// $Rev: 52930 $
// $Date: 2023-04-20 15:46:28 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AISS16AO2_IOCTL_AO_CHAN_SEL,
			/* arg		*/	0,
			/* reg		*/	AISS16AO2_GSC_BOOR,
			/* mask		*/	0x3,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;
	s32	qty		= 8;

	errs	+= aiss16ao2_query(fd, -1, 0, AISS16AO2_QUERY_CHANNEL_AO_QTY, &qty);

	if (errs)
	{
	}
	else if (qty == 0)
	{
		printf("SKIPPED  (No output channels present.)\n");
	}
	else
	{
		for (i = 0; i < (int) qty; i++)
		{
			list[0].arg		= 0x1 << i;
			list[0].value	= 0x1 << i;

			errs	+= aiss16ao2_initialize(fd, -1, 0);

			errs	+= service_ioctl_set_reg_list(fd, list);
			errs	+= service_ioctl_reg_get_list(fd, list);

			errs	+= service_ioctl_set_reg_list(fd, list);
			errs	+= service_ioctl_reg_get_list(fd, list);

			errs	+= aiss16ao2_initialize(fd, -1, 0);
		}
	}

	return(errs);
}




//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment to verify.
	return(0);
}




/******************************************************************************
*
*	Function:	ao_chan_sel_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_AO_CHAN_SEL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ao_chan_sel_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_AO_CHAN_SEL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


