// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/dio_read.c $
// $Rev: 52930 $
// $Date: 2023-04-20 15:46:28 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AISS16AO2_GSC_DIOPR,
			/* mask		*/	0x3F00,
			/* value	*/	0x3F00
		},
		{
			/* service	*/	SERVICE_REG_MOD,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AISS16AO2_GSC_DIOPR,
			/* mask		*/	0x3F,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	s32	get;
	int	i;
	int	ret;
	s32	set;

	for (i = 0; i < 6; i++)
	{
		errs	+= aiss16ao2_initialize(fd, -1, 0);

		// Walking one.
		set				= 1 << i;
		list[1].value	= set;
		errs			+= service_ioctl_set_reg_list(fd, list);
		ret				= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_DIO_READ, &get);
		errs			+= ret ? 1 : 0;

		if (set != get)
		{
			errs++;
			printf(	"FAIL <---  (%d. i %d, set 0x%02lX != get 0x%02lX)\n",
					__LINE__,
					i,
					(long) set,
					(long) get);
		}

		// walking zero.
		set				= 0x3F ^ (1 << i);
		list[1].value	= set;
		errs			+= service_ioctl_set_reg_list(fd, list);
		ret				= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_DIO_READ, &get);
		errs			+= ret ? 1 : 0;

		if (set != get)
		{
			errs++;
			printf(	"FAIL <---  (%d. i %d, set 0x%02lX != get 0x%02lX)\n",
					__LINE__,
					i,
					(long) set,
					(long) get);
		}

		errs	+= aiss16ao2_initialize(fd, -1, 0);
	}

	return(errs);
}




//*****************************************************************************
static int _function_test(int fd)
{
	// This test is the same as the service test.
	return(0);
}




/******************************************************************************
*
*	Function:	dio_read_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_DIO_READ.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio_read_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_DIO_READ");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


