// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/gen_x_ndiv.c $
// $Rev: 52930 $
// $Date: 2023-04-20 15:46:28 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd, s32 cmd, s32 reg)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	cmd,
			/* arg		*/	0,
			/* reg		*/	reg,
			/* mask		*/	0x00FFFFFF,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;
	int	i;

	for (i = 0; i < 24; i++)
	{
		errs	+= aiss16ao2_initialize(fd, -1, 0);

		// Walking one
		list[0].arg		= (1L << i) | (45);
		list[0].value	= (1L << i) | (45);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		// Walking zero.
		list[0].arg		= (0x00FFFFFF ^ (1L << i)) | (45);
		list[0].value	= (0x00FFFFFF ^ (1L << i)) | (45);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= service_ioctl_set_reg_list(fd, list);
		errs	+= service_ioctl_reg_get_list(fd, list);

		errs	+= aiss16ao2_initialize(fd, -1, 0);
	}

	return(errs);
}



//*****************************************************************************
static int _function_a_test(int fd)
{
	// This requires additional equipment to test.
	return(0);
}



//*****************************************************************************
static int _function_b_test(int fd)
{
	// This requires additional equipment to test.
	return(0);
}



//*****************************************************************************
static int _function_c_test(int fd)
{
	// This requires additional equipment to test.
	return(0);
}



/******************************************************************************
*
*	Function:	gen_a_ndiv_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_GEN_A_NDIV.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int gen_a_ndiv_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_GEN_A_NDIV");
	errs	+= _service_test(fd, AISS16AO2_IOCTL_GEN_A_NDIV, AISS16AO2_GSC_RGAR);
	errs	+= _function_a_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}



/******************************************************************************
*
*	Function:	gen_b_ndiv_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_GEN_B_NDIV.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int gen_b_ndiv_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_GEN_B_NDIV");
	errs	+= _service_test(fd, AISS16AO2_IOCTL_GEN_B_NDIV, AISS16AO2_GSC_RGBR);
	errs	+= _function_b_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}



/******************************************************************************
*
*	Function:	gen_c_ndiv_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_GEN_C_NDIV.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int gen_c_ndiv_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_GEN_C_NDIV");
	errs	+= _service_test(fd, AISS16AO2_IOCTL_GEN_C_NDIV, AISS16AO2_GSC_RGCR);
	errs	+= _function_c_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


