// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/master_clock.c $
// $Rev: 52930 $
// $Date: 2023-04-20 15:46:28 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	int		errs	= 0;
	s32		get;
	s32		init	= -1;
	long	l;
	int		ret;
	s32		set;

	ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_MASTER_CLOCK, &init);
	errs	+= ret ? 1 : 0;

	for (	l = AISS16AO2_MASTER_CLOCK_MIN;
			l <= AISS16AO2_MASTER_CLOCK_MAX;
			l += 1000000L)
	{
		set		= l;
		ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_MASTER_CLOCK, &set);
		errs	+= ret ? 1 : 0;
		get		= -1;
		ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_MASTER_CLOCK, &get);
		errs	+= ret ? 1 : 0;

		if ((errs == 0) && (get != set))
		{
			errs++;
			printf(	"FAIL <---  (%d. set %ld, got %ld)\n",
					__LINE__,
					(long) set,
					(long) get);
		}
	}

	ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_MASTER_CLOCK, &init);
	errs	+= ret ? 1 : 0;

	return(errs);
}




//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment to test.
	return(0);
}




/******************************************************************************
*
*	Function:	master_clock_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_MASTER_CLOCK.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int master_clock_test(int fd)
{
	int	errs	= 0;

	gsc_label("AISS16AO2_IOCTL_MASTER_CLOCK");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


