// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/sbtest/query.c $
// $Rev: 52930 $
// $Date: 2023-04-20 15:46:28 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



/******************************************************************************
*
*	Function:	query_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AISS16AO2_IOCTL_QUERY. We test only the
*		overall service, not the values returned.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int query_test(int fd)
{
	s32	data;
	s32	count;
	int	errs;
	int	i;

	gsc_label("AISS16AO2_IOCTL_QUERY");
	errs	= aiss16ao2_query(fd, -1, 0, AISS16AO2_QUERY_COUNT, &count);

	if (count != (AISS16AO2_IOCTL_QUERY_LAST + 1))
	{
		errs	= 1;
		printf(	"FAIL <---  (expected %ld, got %ld, rebuild application)\n",
				(long) AISS16AO2_IOCTL_QUERY_LAST + 1,
				(long) count);
	}
	else
	{
		for (i = 0; (errs == 0) && (i <= AISS16AO2_IOCTL_QUERY_LAST); i++)
			errs	= aiss16ao2_query(fd, -1, 0, i, &data);

		if (errs == 0)
			printf("PASS\n");
	}

	return(errs);
}


