// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/samples/signals/perform.c $
// $Rev: 52929 $
// $Date: 2023-04-20 15:43:30 -0500 (Thu, 20 Apr 2023) $

// 16AISS16AO2: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	//===============================================================
	gsc_label("Setup");
	printf("\n");
	gsc_label_level_inc();

	errs	+= aiss16ao2_initialize		(args->fd, -1, 1);


	errs	+= aiss16ao2_ai_burst_enable(args->fd, -1, 1, AISS16AO2_BURST_ENABLE_YES, NULL);
	errs	+= aiss16ao2_gen_a_ndiv		(args->fd, -1, 1, 45, NULL);
	errs	+= aiss16ao2_gen_a_enable	(args->fd, -1, 1, AISS16AO2_GEN_ENABLE_YES, NULL);
	errs	+= aiss16ao2_ai_clock_mode	(args->fd, -1, 1, AISS16AO2_CLOCK_MODE_OUT, NULL);

	errs	+= aiss16ao2_gen_b_ndiv		(args->fd, -1, 1, 46, NULL);
	errs	+= aiss16ao2_gen_b_enable	(args->fd, -1, 1, AISS16AO2_GEN_ENABLE_YES, NULL);
	errs	+= aiss16ao2_trigger_mode	(args->fd, -1, 1, AISS16AO2_TRIGGER_MODE_OUT, NULL);

	errs	+= aiss16ao2_gen_c_ndiv		(args->fd, -1, 1, 47, NULL);
	errs	+= aiss16ao2_gen_c_enable	(args->fd, -1, 1, AISS16AO2_GEN_ENABLE_YES, NULL);
	errs	+= aiss16ao2_ao_clock_mode	(args->fd, -1, 1, AISS16AO2_CLOCK_MODE_OUT, NULL);

	gsc_label_level_dec();

	//===============================================================
	gsc_label("Waiting");
	printf("%d seconds ... ", args->seconds);
	fflush(stdout);
	os_sleep_ms(args->seconds * 1000);
	printf("Done\n");

	errs	+= aiss16ao2_initialize		(args->fd, -1, 1);

	return(errs);
}



