// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AISS16AO2/utils/util_ao_thresh_lvl.c $
// $Rev: 44439 $
// $Date: 2019-02-13 10:58:37 -0600 (Wed, 13 Feb 2019) $

// 16AISS16AO2: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aiss16ao2_ao_thresh_lvl
*
*	Purpose:
*
*		Provide a visual wrapper for the AISS16AO2_IOCTL_AO_THRESH_LVL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	aiss16ao2_ao_thresh_lvl(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("AO Threshold Level", index);

	ret		= aiss16ao2_ioctl(fd, AISS16AO2_IOCTL_AO_THRESH_LVL, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf("%s  (", errs ? "FAIL <---" : "PASS");
		gsc_label_long_comma((long) set);
		printf(", 0x%lX)\n", (long) set);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


